var files = new Array();
var increment = 0;

function alert(msg)
{
    System.Debug.outputString(msg);
}

function onLoad()
{
    try
    {
        System.Gadget.settingsUI = "settings.htm";
        var dir = System.Gadget.Settings.read("videoPath");
        
        if(dir == "")
        {
            dir = "C:\\Users\\Public\\Videos\\Sample Videos";
        }
        System.Gadget.onSettingsClosing = SettingsClosing;
        
        LoadFiles(dir);
        StartRotator();
    }
    catch(e)
    {
        alert(e.description);
    }
}

function SettingsClosing()
{
    files = new Array();
    try
    {
        var dir = System.Gadget.Settings.read("videoPath");
             
        LoadFiles(dir);
        StartRotator();
    }
    catch(e)
    {
        alert(e.description);
    }
}

var cancelID;
function Previous()
{
    clearTimeout(cancelID);
    if(increment <= 0)
    {
        increment = (files.length - 1);
    }
    else
    {
        increment--;
    }
    var item = files[increment];
    var media = document.getElementById("SilverlightControl").content.findName("mediaPlayerControl");
    media.Source = item;
    waitTimer();
}

function Next()
{
    clearTimeout(cancelID);
    
    if(increment == (files.length - 1))
    {
        increment = 0;
    }
    else
    {
        increment++;
    }
    var item = files[increment];
    var media = document.getElementById("SilverlightControl").content.findName("mediaPlayerControl");
    media.Source = item;
    waitTimer();
}

function StartRotator()
{
    alert("StartRotator Start");
    var silverlight = document.getElementById("SilverlightControl");
    var media = silverlight.content.findName("mediaPlayerControl");
    alert(media.CurrentState);
    
    if(media.CurrentState != 'Playing')
    {
        if(increment < files.length)
        {
            var item = files[increment];
            media.Source = item
            increment++;
        }
        else
        {
            increment = 0;
            var item = files[increment];
            media.Source = item
        }
    }
    
    waitTimer();
}

function waitTimer()
{
    alert("Waiting");
    cancelID = setTimeout("StartRotator();", 15000);
   
}

function LoadFiles(dir)
{
    alert("LoadFiles Start: " + dir);
    
    var oShellItem = System.Shell.itemFromPath(dir).SHFolder.Items;
    for (var i = 0; i < oShellItem.count; i++)
    {
        if(!oShellItem.item(i).isFolder) //TODO OR lnk
        {
            files.push(oShellItem.item(i).path);
        }
        else
        {
            LoadFiles(oShellItem.item(i).path);
        }    
    }
    alert("LoadFiles End with: " + oShellItem.count);
}
