if (!window.SilverlightVideoPlayerGadget)
	window.SilverlightVideoPlayerGadget = {};

SilverlightVideoPlayerGadget.Scene = function() 
{
}

SilverlightVideoPlayerGadget.Scene.prototype =
{
	handleLoad: function(control, userContext, rootElement) 
	{
	    alert("Scene handleLoad Start");
	    try
	    {
	        this.rootElement = rootElement;
		    this.control = control;
		    this.control.content.onfullScreenChange = "onFullScreenChanged";
		    
		    this.rootElement.addEventListener("MouseLeave", Sys.Silverlight.createDelegate(this, this.hideControls));
		    this.rootElement.addEventListener("MouseEnter", Sys.Silverlight.createDelegate(this, this.showControls));
		    this.control.content.findName("stop").addEventListener("MouseLeftButtonDown", Sys.Silverlight.createDelegate(this, this.mediaStop));
		    this.control.content.findName("play").addEventListener("MouseLeftButtonDown", Sys.Silverlight.createDelegate(this, this.mediaStart));
		    this.control.content.findName("fullscreen").addEventListener("MouseLeftButtonDown", Sys.Silverlight.createDelegate(this, this.mediaFullScreen));
		    this.control.content.findName("previous").addEventListener("MouseLeftButtonDown", Sys.Silverlight.createDelegate(this, this.mediaPrevious));
		    this.control.content.findName("next").addEventListener("MouseLeftButtonDown", Sys.Silverlight.createDelegate(this, this.mediaNext));
		    
        }
        catch (e)
        {
            alert(e.description);
        }
        
	    alert("Scene handleLoad End");
	},
	
    mediaStop: function(sender, eventArgs) 
	{
		alert("Media Stop: " + sender);
		var media = this.control.content.findName("mediaPlayerControl");
		media.stop(); 
	},
	
	mediaStart: function(sender, eventArgs) 
	{
	    alert("Media Start: " + sender);
		var media = this.control.content.findName("mediaPlayerControl");
		alert(media);
		media.play(); 
	},
	
	mediaFullScreen: function(sender, eventArgs) 
	{
	    alert("Media Full Screen");
		this.control.content.fullScreen = 'true';
	},
	
	mediaPrevious: function(sender, eventArgs)
	{
	    Previous();
	},
	
	mediaNext: function(sender, eventArgs)
	{
	    Next();
	},
	
	showControls: function(sender, eventArgs) 
	{
	    alert("Show Controls");
	    if(sender.getHost().content.fullScreen != true)
	    {
		    this.control.content.findName("showControls").Begin(); 
		}
		else 
		{
		}
	},

	hideControls: function(sender, eventArgs) 
	{
	    alert("Hide Controls");
		if(sender.getHost().content.fullScreen != true)
	    {
		    this.control.content.findName("hideControls").Begin(); 
		}
		else {}
	}
}

function onFullScreenChanged(sender, args)
{
    var silverlightControl = sender.getHost();
    var controlsPanel = sender.findName("controls");
    var border = sender.findName("mainBorder");
    
    if (silverlightControl.content.fullScreen == true)
    {
        controlsPanel.opacity = 0;
        border.opacity = 0;
    }
    else 
    {
        controlsPanel.opacity = 1;
        border.opacity = 1;
    }
    
    var mediaPlayer = sender.findName("mediaPlayerControl");
    mediaPlayer.width = silverlightControl.content.actualWidth;
    mediaPlayer.height = silverlightControl.content.actualHeight;
    mediaPlayer.play();
}